<?php
define ('DATAFILE','zlinks');

function xReadFile($p_fname) {
  if (file_exists($p_fname)) {
    $fd = fopen ($p_fname, 'r'); $x_content = fread ($fd,filesize($p_fname));
    fclose($fd); return $x_content;
  } return null; }

function xWriteFile ($p_filename,$p_content,$p_append) {
  if ($p_append) { $mode='a+'; } else { $mode='w+'; }
  $x_handle = fopen($p_filename,$mode); 
  if ($x_handle) { fwrite($x_handle,$p_content); fclose($x_handle); return true; }
  return false; }

function xGetAttr($p_name,$buffer) {
  $fpos = strpos($buffer,' '.$p_name.'="'); if ($fpos === false) { return ''; } 
  $epos = strpos($buffer, '"',$fpos+strlen($p_name)+3);
  return substr($buffer, $fpos+strlen($p_name)+3,$epos-$fpos-strlen($p_name)-3); }

function xCommand ($arg) {
  $command = substr($arg,1,4); 

  $tf = xGetAttr('tf',$arg); if ($tf!='') { $arg = str_replace(' tf="'.$tf.'"','',$arg); } 
  $df = xGetAttr('df',$arg); if ($df!='') { $arg = str_replace(' df="'.$df.'"','',$arg); } 
  if ($command=='item') {
      if (xGetAttr('fn',$arg)=='a') { $id='fl'.time(); $arg = str_replace('%id%',$id,$arg);  }
      xWriteFile($df,$arg."\n",true); 
      echo '<ret uid="'.$id.'"/>'; 
  }

  if ($command=='data') { 
      xWriteFile ('./zlinks_a.log',date("m d H:i:s ").$_SERVER['REMOTE_ADDR']."\n",true);
      echo xReadFile($df);  }

  if ($command=='load') { echo xReadFile($tf); }

  if ($command=='save') {  
      $suid = xGetAttr('uid',$arg);

      $tstuid = xGetAttr('uid',xReadFile($tf));
      if ($suid==$tstuid) {
        $fpos = strpos($arg,'>');
        $epos = strpos($arg,'</tree>');
        $ndata = substr($arg,$fpos+1,$epos-$fpos+6);
        $id=time();
        $fpos = strpos($ndata,'>');
        $ndata = '<tree uid="'.$id.'">'.substr($ndata,$fpos+1);
        xWriteFile($tf,$ndata,false);
        $patch = substr($arg,$epos+7);
        if ($patch!='') {
          $iid='fl'.time();
          $patch = str_replace('%id%',$iid,$patch);
          xWriteFile($df,$patch."\n",true);
        }
        echo '<ret uid="'.$id.'"/>';
      } else { echo '<ret/>'; }
  }
  
  if ($command=='user') { 
      $usr_data = xReadFile(DATAFILE.'_user.xml');
      $ip = strpos($usr_data,$arg);
      if ($ip===false) { echo '<ret res="ERR"/>'; }
      else { echo '<ret res="OK"/>'; }
  }

  if ($command=='pack') { 
      $old_data = xReadFile($df);
      $suid = xGetAttr('uid',$arg);
      $fpos = strpos($arg,'>');
      $ndata = substr($arg,$fpos+1);
      $fstr = 'uid="'.$suid;
      $restp= strpos($old_data,$fstr);
      if ($restp === false)  { echo ''; exit; }
      while ($nrestp=strpos($old_data,$fstr,$restp+1)) { $restp = $nrestp; }
      $restp=strpos($old_data,'>',$restp+1);
      if ($restp === false)  { echo ''; exit; }
      if ($old_data[$restp-1]!='/') {
        $restp=strpos($old_data,'>',$restp+1);
        if ($restp === false)  { echo ''; exit; }
      }  
      $rest = trim(substr($old_data,$restp+1));  
      xWriteFile($df,$ndata.$rest,false); 
      xWriteFile(DATAFILE.'_temp.xml',"\n".$old_data."\n",true);
      echo '<ret res="OK"/>';
  }

  exit;
}

if  ($GLOBALS['HTTP_RAW_POST_DATA']) { xCommand($GLOBALS['HTTP_RAW_POST_DATA']); }
else { xCommand($HTTP_RAW_POST_DATA); }

?>